%define name jappix
%define version 1.1.2
%define codename primo
%define release 1.beta0
%define httpuser apache

%if 0%{?fedora} >= 11 || 0%{?rhel} >= 5
%global useselinux 1
%else
%global useselinux 0
%endif

Summary: XMPP web client
Name: %{name}
Version: %{version}
Release: %{release}%{?dist}
Distribution: SME Server
License: GPLv2+
URL: https://project.jappix.com/
Group: Applications/Internet
Source: http://download.jappix.org/jappixorg/%{name}-%{version}-%{codename}.zip

Patch1: jappix-1.1.1-no_chmod_777.patch
Patch2: jappix-1.0.1-auth_cas.patch
Patch3: jappix-1.0.1-log_path.patch

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}

Requires: php
Requires: php-pear-CAS
Requires: httpd

%description
Jappix is a fresh new open social platform which enables
you to create your own cloud, wherever you want to.
People must be able to get in touch with all their friends
on a free decentralized network!

%prep
%setup -q -n %{name}
%patch1 -p1
%patch2 -p1
%patch3 -p1

%{__rm} -rf store tmp log

cat <<EOF >%{name}.httpd
# %{name}
# %{summary}
# %{version} (%{codename})
#

Alias /%{name} %{_datadir}/%{name}

<Directory %{_datadir}/%{name}>
    Options +FollowSymlinks
    Order Allow,Deny
    Allow from 127.0.0.1 ::1
    php_admin_flag file_uploads on
    php_admin_value upload_max_filesize 15M
    php_admin_value post_max_size 15M
    php_admin_value memory_limit 64M
    php_admin_value max_execution_time 900
    php_admin_value allow_url_fopen on
    php_admin_value upload_tmp_dir /var/lib/jappix/tmp
    php_admin_value session.save_path /var/lib/jappix/tmp
    php_admin_value open_basedir %{_datadir}/%{name}/:%{_datadir}/pear:%{_sysconfdir}/%{name}:%{_localstatedir}/lib/%{name}:%{_localstatedir}/log/%{name}:%{_localstatedir}/cache/%{name}:/etc/pki/tls/certs
</Directory>

<Directory %{_datadir}/%{name}/lang>
    Order Deny,Allow
    Deny from all
</Directory>

<Directory %{_localstatedir}/lib/%{name}/tmp>
    Order Deny,Allow
    Deny from all
</Directory>

EOF



%build
# empty build

%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__mkdir} -p %{buildroot}/%{_datadir}/%{name}/

for a in $(find ./ -mindepth 1 -maxdepth 1 -type d -print); do
    cp -fr $a %{buildroot}/%{_datadir}/%{name}/
done
cp *.php *.ico VERSION %{buildroot}/%{_datadir}/%{name}/

%{__mkdir} -p %{buildroot}/%{_localstatedir}/lib/%{name}/{access,avatars,backgrounds,music,share,updates,tmp}
%{__mkdir} -p %{buildroot}/%{_localstatedir}/lib/%{name}/tmp/{archives,send}
%{__ln_s} %{_localstatedir}/lib/%{name}/tmp %{buildroot}/%{_datadir}/%{name}/tmp
%{__ln_s} %{_localstatedir}/cache/%{name} %{buildroot}/%{_localstatedir}/lib/%{name}/tmp/cache
%{__ln_s} %{_localstatedir}/lib/%{name} %{buildroot}/%{_datadir}/%{name}/store

%{__mkdir} -p %{buildroot}/%{_sysconfdir}/%{name}
%{__ln_s} %{_sysconfdir}/%{name} %{buildroot}/%{_localstatedir}/lib/%{name}/conf

%{__mkdir} -p %{buildroot}/%{_localstatedir}/log/%{name}
%{__ln_s} %{_localstatedir}/log/%{name} %{buildroot}/%{_datadir}/%{name}/log

%{__mkdir} -p %{buildroot}/%{_localstatedir}/cache/%{name}

%{__mkdir} -p %{buildroot}/%{_sysconfdir}/httpd/conf.d/
%{__install} -p -m 0644 %{name}.httpd %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf

%clean
rm -rf %{buildroot}

%post
%if %{useselinux}
(
# New File context
semanage fcontext -a -s system_u -t httpd_log_t           -r s0 "%{_localstatedir}/log/%{name}(/.*)?"
# keep httpd_sys_script_rw_t (httpd_var_lib_t prevent dir creation)
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_localstatedir}/lib/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_localstatedir}/cache/%{name}(/.*)?"
# files created by app
restorecon -R %{_sysconfdir}/%{name}
restorecon -R %{_localstatedir}/lib/%{name}
restorecon -R %{_localstatedir}/log/%{name}
restorecon -R %{_localstatedir}/cache/%{name}
) &>/dev/null || :
%endif

%postun
%if %{useselinux}
if [ "$1" -eq "0" ]; then
    # Remove the File Context
    (
    semanage fcontext -d "%{_localstatedir}/log/%{name}(/.*)?"
    semanage fcontext -d "%{_localstatedir}/lib/%{name}(/.*)?"
    semanage fcontext -d "%{_localstatedir}/cache/%{name}(/.*)?"
    ) &>/dev/null || :
fi
%endif

%files
%defattr(-,root,root)
%doc *.md
%{_datadir}/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/*
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/tmp/*
%{_localstatedir}/lib/%{name}/*
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/log/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/cache/%{name}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%dir %attr(770,root,%{httpuser}) %{_sysconfdir}/%{name}/


%changelog
* Tue Oct 14 2014 Daniel Berteaud <daniel@firewall-services.com> 1.1.2-1
- Update to 1.1.2

* Thu Sep 11 2014 Daniel Berteaud <daniel@firewall-services.com> 1.1.1-1
- Update to 1.1.1 (primo)

* Wed Jun 25 2014 Daniel Berteaud <daniel@firewall-services.com> 1.1.0-1
- Update to 1.1.0 (primo)

* Wed May 28 2014 Daniel Berteaud <daniel@firewall-services.com> 1.0.7-1
- Update to 1.0.7

* Mon May 19 2014 Daniel Berteaud <daniel@firewall-services.com> 1.0.5-1
- Update to 1.0.5

* Mon Apr 14 2014 Daniel Berteaud <daniel@firewall-services.com> 1.0.3-1
- update to 1.0.3
- Fix httpd conf

* Thu Jan 30 2014 Daniel Berteaud <daniel@firewall-services.com> 1.0.1-1
- update to 1.0.1 (one)

* Fri Nov 15 2013 Daniel Berteaud <daniel@firewall-services.com> 0.9.9-2
- Spec file cleanup

* Wed Aug 21 2013 Daniel Berteaud <daniel@firewall-services.com> 0.9.9-1
- update to 0.9.9 (nemesis-alpha-9)

* Fri Jul 5 2013 Daniel Berteaud <daniel@firewall-services.com> 0.9.8-1
- update to 0.9.8 (nemesis-alpha-8)
- Allow access to /etc/pki/tls/certs
- Don't move VERSION in the doc folder

* Tue May 14 2013 Daniel Berteaud <daniel@firewall-services.com> 0.9.4-1
- update to 0.9.4 (nemesis-alpha-4)

* Thu Apr 4 2013 Daniel Berteaud <daniel@firewall-services.com> 0.9.3-1
- update to 0.9.3 (nemesis-alpha-3)

* Sun Jul 15 2012 Daniel Berteaud <daniel@firewall-services.com> 0.9.1-1
- update to 0.9.1 (nemesis-alpha-1)

* Fri Jul 13 2012 Daniel Berteaud <daniel@firewall-services.com> 0.9-5
- Stop including phpCAS, requires php-pear-CAS

* Fri Mar 30 2012 Daniel Berteaud <daniel@firewall-services.com> 0.9-4
- Use higher priority for resource (80)

* Wed Jan 25 2012 Daniel Berteaud <daniel@firewall-services.com> 0.9-3
- Upstream upgrade to 0.9 (spaco)

* Tue Dec 20 2011 Daniel Berteaud <daniel@firewall-services.com> 0.8-3
- Add a patch to support CAS authentication

* Wed Sep 28 2011 Daniel Berteaud <daniel@firewall-services.com> 0.8-2
- Do not exit with error if SELinux is disabled

* Thu Sep 01 2011 Daniel Berteaud <daniel@firewall-services.com> 0.8-1
- Upstream upgrade to 0.8 (suno)

* Sat Jul 09 2011 Daniel Berteaud <daniel@firewall-services.com> 0.7-1
- initial release

